#!/bin/sh

GODOT_BIN="${GODOT_BIN:-godot}"

set -e

[ -d .git ] || git init
if [ ! -d godot-cpp ]; then
  git submodule add -b 4.2 https://github.com/godotengine/godot-cpp
  cd godot-cpp
  git submodule update --init
  cd ..
fi

"$GODOT_BIN" --dump-extension-api

cd godot-cpp
scons platform=linux custom_api_file=../extension_api.json
cd ..

scons platform=linux
scons platform=linux target=template_release

echo Done
