#include "register_types.h"

#include "my_editor_plugin_base.h"

#include <gdextension_interface.h>
#include <godot_cpp/core/defs.hpp>
#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/editor_plugin_registration.hpp>

using namespace godot;

void initialize_my_module(ModuleInitializationLevel p_level) {
    if (p_level != MODULE_INITIALIZATION_LEVEL_EDITOR) {
        return;
    }

    ClassDB::register_class<MyEditorPluginBase>();
    
    // do NOT add MyEditorPluginBase here because it is used as a base class for the GDScript plugin
    // (but you can uncomment this line to check if MyEditorPluginBase itself works)
    // EditorPlugins::add_by_type<MyEditorPluginBase>();
}

void uninitialize_my_module(ModuleInitializationLevel p_level) {
    if (p_level != MODULE_INITIALIZATION_LEVEL_EDITOR) {
        return;
    }

    // EditorPlugins::remove_by_type<MyEditorPluginBase>();
}

extern "C" {
// Initialization.
GDExtensionBool GDE_EXPORT my_library_init(GDExtensionInterfaceGetProcAddress p_get_proc_address, const GDExtensionClassLibraryPtr p_library, GDExtensionInitialization *r_initialization) {
    godot::GDExtensionBinding::InitObject init_obj(p_get_proc_address, p_library, r_initialization);

    init_obj.register_initializer(initialize_my_module);
    init_obj.register_terminator(uninitialize_my_module);
    init_obj.set_minimum_library_initialization_level(MODULE_INITIALIZATION_LEVEL_EDITOR);

    return init_obj.init();
}
}
